## org.apache.lucene.search.join
Class ToParentBlockJoinQuery

    java.lang.Object
      org.apache.lucene.search.Query
          org.apache.lucene.search.join.ToParentBlockJoinQuery

All Implemented Interfaces:
  Cloneable

    public class ToParentBlockJoinQuery

extends Query

This query requires that you index children and parent docs as a single block, using the `IndexWriter.addDocuments()` or `IndexWriter.updateDocuments()` API. In each block, the child documents must appear first, ending with the parent document. At search time you provide a Filter identifying the parents, however this Filter must provide an `FixedBitSet` per sub-reader.

Once the block index is built, use this query to wrap any sub-query matching only child docs and join matches in that child document space up to the parent document space. You can then use this Query as a clause with other queries in the parent document space.

See `ToChildBlockJoinQuery` if you need to join in the reverse order.

The child documents must be orthogonal to the parent documents: the wrapped child query must never return a parent document.

If you'd like to retrieve `TopGroups` for the resulting query, use the `ToParentBlockJoinCollector`. Note that this is not necessary, ie, if you simply want to collect the parent documents and don't need to see which child documents matched under that parent, then you can use any collector.

NOTE: If the overall query contains parent-only matches, for example you OR a parent-only query with a joined child-only query, then the resulting collected documents will be correct, however the `TopGroups` you get from `ToParentBlockJoinCollector` will not contain every child for parents that had matched.

See `org.apache.lucene.search.join` for an overview.

WARNING: This API is experimental and might change in incompatible ways in the next release.

Constructor Summary
`ToParentBlockJoinQuery(Query childQuery, Filter parentsFilter, ScoreMode scoreMode)` Create a ToParentBlockJoinQuery.

Method Summary
`ToParentBlockJoinQuery` `clone()`
`Weight` `createWeight(IndexSearcher searcher)`
`boolean` `equals(Object _other)`
`void` `extractTerms(Set<Term> terms)`
`int` `hashCode()`
`Query` `rewrite(IndexReader reader)`
`String` `toString(String field)`

Methods inherited from class org.apache.lucene.search.Query
`getBoost, setBoost, toString`

Methods inherited from class java.lang.Object
`finalize, getClass, notify, notifyAll, wait, wait, wait`

Constructor Detail

### ToParentBlockJoinQuery

    public ToParentBlockJoinQuery(Query childQuery,
                                  Filter parentsFilter,
                                  ScoreMode scoreMode)

  Create a ToParentBlockJoinQuery.

  Parameters:
    `childQuery` - Query matching child documents.
    `parentsFilter` - Filter (must produce FixedBitSet per-segment) identifying the parent documents.
    `scoreMode` - How to aggregate multiple child scores into a single parent score.

Method Detail

### createWeight

    public Weight createWeight(IndexSearcher searcher)
                        throws IOException

  Overrides:
    `createWeight` in class `Query`
  Throws:
    `IOException`

### extractTerms

    public void extractTerms(Set<Term> terms)

  Overrides:
    `extractTerms` in class `Query`

### rewrite

    public Query rewrite(IndexReader reader)
                  throws IOException

  Overrides:
    `rewrite` in class `Query`
  Throws:
    `IOException`

### toString

    public String toString(String field)

  Specified by:
    `toString` in class `Query`

### equals

    public boolean equals(Object _other)

  Overrides:
    `equals` in class `Query`

### hashCode

    public int hashCode()

  Overrides:
    `hashCode` in class `Query`

### clone

    public ToParentBlockJoinQuery clone()

  Overrides:
    `clone` in class `Query`

Copyright © 2000-2013 Apache Software Foundation. All Rights Reserved.